#
# See the file "LICENSE" for the full license governing this code.
#
#++--++
#--++--
#
define pg_secured::internal::ensure_extension (
  String[1] $ensure_libraries,
) {
  if $facts['pg_major_version'] != undef {
    $instance  = $title.split('@')[1]
    $extension = $title.split('@')[0]
    $extensions = dig($facts, 'pg_extensions')
    if $extensions {
      $selected_extension = $extensions.filter |$ext| { $ext['name'] == $extension }.dig(0)
    } else {
      $selected_extension = undef
    }
    if $selected_extension == undef {
      debug("extension ${extension} not loaded")
      if $ensure_libraries == 'skip' {
        debug('Skipping ensuring libraries')
      } else {
        contain $ensure_libraries
        Class[$ensure_libraries] -> Pg_extension["${extension}@${instance}"]
      }
    }
    pg_extension { "${extension}@${instance}":
      ensure  => 'present',
    }
  } else {
    warning 'Postgres version not (yet) known. Skipping this control for now'
  }
}
